from _typeshed import Incomplete
from micropython import const as const

_CMD_SYNC: int
_CMD_CHANGE_BAUDRATE: int
_CMD_ESP_READ_REG: int
_CMD_ESP_WRITE_REG: int
_CMD_SPI_ATTACH: int
_CMD_SPI_FLASH_MD5: int
_CMD_SPI_FLASH_PARAMS: int
_CMD_SPI_FLASH_BEGIN: int
_CMD_SPI_FLASH_DATA: int
_CMD_SPI_FLASH_END: int
_FLASH_ID: int
_FLASH_REG_BASE: int
_FLASH_BLOCK_SIZE: Incomplete
_FLASH_SECTOR_SIZE: Incomplete
_FLASH_PAGE_SIZE: int
_ESP_ERRORS: Incomplete

class ESPFlash:
    uart: Incomplete
    reset_pin: Incomplete
    gpio0_pin: Incomplete
    log: Incomplete
    baudrate: int
    md5sum: Incomplete
    def __init__(self, reset, gpio0, uart, log_enabled: bool = False) -> None: ...
    def _log(self, data, out: bool = True) -> None: ...
    def _uart_drain(self) -> None: ...
    def _read_reg(self, addr): ...
    def _write_reg(self, addr, data, mask: int = 4294967295, delay: int = 0) -> None: ...
    def _poll_reg(self, addr, flag, retry: int = 10, delay: float = 0.05) -> None: ...
    def _write_slip(self, pkt) -> None: ...
    def _read_slip(self): ...
    def _strerror(self, err): ...
    def _checksum(self, data): ...
    def _command(self, cmd, payload: bytes = b"", checksum: int = 0): ...
    def set_baudrate(self, baudrate, timeout: int = 350) -> None: ...
    def bootloader(self, retry: int = 6): ...
    def flash_read_size(self): ...
    def flash_attach(self) -> None: ...
    def flash_config(self, flash_size=...) -> None: ...
    def flash_write_file(self, path, blksize: int = 4096) -> None: ...
    def flash_verify_file(self, path, digest: Incomplete | None = None, offset: int = 0) -> None: ...
    def reboot(self) -> None: ...
